--Copyright ElvUI pixelperfect.lua
--Cache global variables
--Lua functions
local abs, floor, min, max = math.abs, math.floor, math.min, math.max
local match = string.match
--WoW API / Variables
local IsMacClient = IsMacClient
local GetCVar, SetCVar = GetCVar, SetCVar
local GetScreenHeight, GetScreenWidth = GetScreenHeight, GetScreenWidth

--Global variables that we don't cache, list them here for the mikk's Find Globals script
-- GLOBALS: UIParent, WorldMapFrame

--Determine if Eyefinity is being used, setup the pixel perfect script.
local scale


-- split("a,b,c", ",") => {"a", "b", "c"}
local function SC_split(s, sep)
    local fields = {}
    
    local sep = sep or " "
    local pattern = string.format("([^%s]+)", sep)
    string.gsub(s, pattern, function(c) fields[#fields + 1] = c end)
    
    return fields
end

--Return rounded number
function SliceCommander:Round(num, idp)
	if(idp and idp > 0) then
		local mult = 10 ^ idp
		return floor(num * mult + 0.5) / mult
	end
	return floor(num + 0.5)
end

function SliceCommander:UIScale(event)
	if not _G['SC'].SET or _G['SC'].SET.PixelPerfect then	
		local screenwidth, screenheight = GetScreenWidth(),GetScreenHeight()
		if screenwidth == nil or screenheight == nil then
			if not _G['SC'].SET then
				return false
			end
			resolution = _G['SC'].SET.fixedResolution
			if resolution == nil then
				SliceCommander:StaticPopup_Show('FAILED_UISCALERESOLUTION')
			end
			return false
		end

		if IsMacClient() and _G['SC'].screenheight and _G['SC'].screenwidth and (screenwidth ~= _G['SC'].screenheight or screenheight ~= _G['SC'].screenwidth) then
			screenheight = _G['SC'].screenheight
			screenwidth = _G['SC'].screenwidth
		end

		if(GetCVar('uiScale')) then
			_G['SC'].uiScale = GetCVar('uiScale')
		end

		scale = max(0.64, min(1.15, 768/screenheight));

		--Set UIScale, NOTE: SetCVar for UIScale can cause taints so only do this when we need to..
		if SliceCommander:Round(UIParent:GetScale(), 5) ~= SliceCommander:Round(scale, 5) and (event == 'PLAYER_LOGIN') then
			SetCVar("useUiScale", 1);
			SetCVar("uiScale", scale);
			WorldMapFrame.hasTaint = true;
		end

		if (event == 'PLAYER_LOGIN' or event == 'UI_SCALE_CHANGED') then
			if IsMacClient() then
				_G['SC'].screenheight = floor(GetScreenHeight()*100+.5)/100
				_G['SC'].screenwidth = floor(GetScreenWidth()*100+.5)/100
			end
			local change = abs((SliceCommander:Round(UIParent:GetScale(), 5) * 100) - (SliceCommander:Round(scale, 5) * 100))

			if event == 'UI_SCALE_CHANGED' and change and change > 1 and _G['SC'].SET.PixelPerfect then
				SliceCommander:StaticPopup_Show('FAILED_UISCALE')
			elseif event == 'UI_SCALE_CHANGED' and change and change > 1 then
				SliceCommander:StaticPopup_Show('CONFIG_RL')
			end
		end
	end
end